
module Main(main,
   primes)

where

import System(getArgs)
import List
import Numeric

main = do args <- getArgs
          let
            m = read (args!!0)  --  number
          putStrLn ("primes of " ++ (show m) ++ " are " ++ show(primes m))

primes:: Int -> [Int]

--primes n = [n]

primes 0 = []
primes 1 = []
primes 2 = [2]
primes (n+2) = let
		pn = primes (fromIntegral (truncate (sqrt (fromIntegral (n+2)))))
               in 
                 pn ++ ([2..n+2] \\ (concat (map (mults (n+2)) pn)))

mults n x = scanl1 (+) (replicate (div n x) x)
s :: Int-> Int
--s n = (fromInteger (toInteger (truncate (sqrt (fromInteger (toInteger n))))))
--s n = (fromIntegral (truncate (sqrt (fromInteger (toInteger n)))))
s n = (fromIntegral (truncate (sqrt (fromIntegral n))))
